#ifndef LIBARAGORN_H
#define LIBARAGORN_H

#include <stdlib.h>
#include <unistd.h>

#include "types.h"
#include "process_group_types.h"
#include "checkpoint.h"

int get_cpu_id(void);
int get_nr_cpu(void);

int find_remote_node(void);
unsigned long get_kerrighed_id (pid_t pid);


/* process migration system calls */
int migrate (pid_t, int);
int migrate_self (int destination_node);
int thread_migrate (pid_t pid, int thread_id, int destination_node);

/* checkpoint/restart/rollback system calls */
checkpoint_infos_t application_checkpoint_from_appid (media_t media, long app_id, int signal);
checkpoint_infos_t application_checkpoint_from_pid(media_t media, pid_t pid, int signal);
checkpoint_infos_t inside_app_checkpoint(void);

int application_restart  (media_t media, long app_id, int chkpt_sn, int flags);

/* process group system calls */
int add_process_in_group (pid_t pid, process_group_id_t groupId);
int gthread_add_in_group (int thread_id, process_group_id_t groupId);
int remove_process_from_group (pid_t pid, process_group_id_t groupId);
int gthread_remove_from_group (int thread_id, process_group_id_t groupId);
int add_node_in_group (kerrighed_node_t node_id, process_group_id_t groupId);
int remove_node_from_group (kerrighed_node_t node_id, process_group_id_t groupId);

int create_krg_struct (int pid) ;

process_group_id_t create_group(void) ;
process_group_id_t get_group(void) ;
int delete_group(process_group_id_t groupId) ;
#endif
